routes/web.php
<?php

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\EventController;
/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    if (Auth::check()) {
        return redirect('events');
    }
    return view('welcome');
});

Route::middleware(['auth:sanctum', 'verified'])->get('/dashboard', function () {
    return view('dashboard');
})->name('dashboard');

Route::middleware(['auth:sanctum', 'verified'])->group(function () {

    Route::GET('invite-members/{event}', [EventController::class, 'inviteMembers']);
    Route::POST('sent-invititation', [EventController::class, 'sentInvite']);
    Route::DELETE('remove-member/{eventuser}', [EventController::class, 'removeMember']);
    Route::get('events/invitation', [EventController::class, 'invitation']);
    Route::get('accept-invitation/{eventuser}', [EventController::class, 'acceptInvitation']);
    Route::POST('events/search', [EventController::class, 'searchEvent']);
    Route::get('events/search', function () {
        return redirect('events');
    });

    //event resource route
    Route::resource('events', EventController::class);
});

app/Models/Event.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Kyslik\ColumnSortable\Sortable;

class Event extends Model
{
    use HasFactory, Sortable;
    public $fillable = [
        'name',
        'description',
        'event_date',
        'event_time',
        'user_id',
    ];
    public $sortable = [
        'id',
        'name',
        'event_date',
        'event_time',
    ];

    //time format
    public function getEventTimeAttribute($value)
    {
        return date('h:i A', strtotime($value));
    }

    //event created user
    public function user()
    {
        return $this->belongsTo(User::class);
    }

    //event invite users
    public function invite()
    {
        return $this->hasMany(EventUser::class);
    }

//     public function eventusers()
//     {
//         return $this->hasMany(EventUser::class, 'event_id', 'id');
//     }
}

app/Http/Controllers/EventController.php
<?php

namespace App\Http\Controllers;

use Carbon\Carbon;
use App\Models\User;
use App\Models\Event;
use App\Models\EventUser;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class EventController extends Controller
{
    public function index()
    {
        $events = Event::sortable()
            ->where('user_id', auth()->user()->id)
            ->orderBy('created_at', 'DESC')
            ->paginate(3);

        return view('events.index', compact('events'));
    }
    public function create()
    {
        //
    }

    public function store(Request $request)
    {
        $this->validate($request, [
            'yesterday' => Carbon::yesterday(),
            'name' => 'required',
            'description' => 'required',
            'event_date' => 'required|date|after:yesterday',
            'event_time' => 'required',
        ]);

        $data = $request->all();
        $data['user_id'] = auth()->user()->id;
        Event::create($data);
        return redirect()->route('events.index')->with('msg', 'Event created successfully');
    }

    public function edit(Event $event)
    {
        return $event;
    }

    public function update(Request $request, Event $event)
    {
        //
    }

    public function destroy(Event $event)
    {
        //
        if ($event->user_id == auth()->id()) {
            EventUser::where('event_id', $event->id)->delete();
            $event->delete();
            return redirect()->route('events.index')->with('msg', 'Event deleted successfully');
        } else {
            return redirect()->route('events.index')->with('msg', 'You are not authorized to delete this event');
        }
    }

    public function inviteMembers(Event $event)
    {
        $users = User::where('id', '!=', auth()->id())->get();
        return view('events.inviteMember', compact('users', 'event'));
    }

    public function sentInvite(Request $request)
    {
        $this->validate($request, [
            'event_id' => 'required',
            'user_id' => 'required',
        ]);
        for ($i = 0; $i < count($request->user_id); $i++) {

            $data['user_id'] = $request->user_id[$i];
            $data['event_id'] = $request->event_id;
            EventUser::create($data);
        }
        return redirect()->route('events.index')->with('msg', 'Members Invited successfully');
    }

    public function removeMember(EventUser $eventuser)
    {
        $event = Event::find($eventuser->event_id);
        if ($event->user_id == auth()->user()->id) {
            if ($eventuser->delete()) {
                return redirect()->route('events.index')->with('msg', 'Members Removed successfully');
            }
        }
        return redirect()->back();
    }

    public function invitation()
    {
        $invitation = EventUser::sortable()->where('user_id', auth()->user()->id)->paginate(5);
        return view('events.invitation', compact('invitation'));
    }

    public function acceptInvitation(EventUser $eventuser)
    {
        if ($eventuser->user_id == auth()->user()->id) {
            $eventuser->update(['is_accept' => true]);
            return redirect('events/invitation')->with('msg', 'Invitation Accepted successfully');
        }
        return redirect()->route('events.indexs');
    }

    public function searchEvent(Request $request)
    {
        $query = $request->search;
        if ($query) {
            $events = Event::sortable()
                ->where([
                    ['name', 'like', '%' . $query . '%'],
                    ['user_id', Auth::user()->id],
                ])
                ->orWhere('description', 'like', '%' . $query . '%')
                ->orderBy('id', 'desc')
                ->get();

            return view('events.search', compact('events'));
        }
        return redirect()->back()->with('msg', 'Please enter atleast one value in field');
    }
}

resources/views/events/addevent-modal.blade.php
<div class="modal fade" id="addEvent" tabindex="-1" role="dialog" aria-labelledby="exampleModalCenterTitle" aria-hidden="true">
    <div class="modal-dialog modal-dialog-centered" role="document">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title" id="exampleModalLongTitle">Modal title</h5>
          <button type="button" class="close" data-dismiss="modal" aria-label="Close">
            <span aria-hidden="true">&times;</span>
          </button>
        </div>
        <div class="modal-body">
        <form action="{{route('events.store')}}" method="post">
            @csrf
            <div class="form-group">
                <label>Event Name</label>
                <input type="text" class="form-control" name="name" id="name"  placeholder="Enter Event Name">
            </div>
            <div class="form-group">
                <label>Event Description</label>
                <input type="text" class="form-control" name="description" placeholder="Enter Event Description">
            </div>
            <div class="form-group">
                <label>Event Date</label>
                <input type="date" class="form-control" name="event_date" placeholder="Enter Event Date">
            </div>
            <div class="form-group">
                <label>Event Time</label>
                <input type="time" class="form-control" name="event_time" placeholder="Enter Event Time">
            </div>
            <div class="form-group">
            </div>
            <div class="modal-footer">
                <button type="submit" class="btn btn-primary btn-block">Create Event</button>
            </div>
        </form>
      </div>
    </div>
  </div>

resources/views/events/addmember-modal.blade.php
<div class="modal fade" id="exampleModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel"
    aria-hidden="true">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="exampleModalLabel">Invite Members</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
                <form action="{{url('invite-members')}}" method="post">
                    @csrf
                    <div class="input-group mb-3">
                        <div class="input-group-prepend">
                            <label class="input-group-text" for="inputGroupSelect01">Select members</label>
                        </div>
                        <select name="members[]" class="custom-select" id="inputGroupSelect01" multiple>
                            @foreach ($users as $item)
                                <option value="{{ $item->id }}">{{ $item->name }}</option>
                            @endforeach
                        </select>
                    </div>

            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                <button type="submit" class="btn btn-primary btn-block">Sent Invitation</button>
            </div>
        </form>
        </div>
    </div>
</div>

resources/views/events/app.blade.php
<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Event Management system</title>
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css">
</head>

<body>
    <nav class="navbar navbar-expand-lg navbar-light bg-light">
        <a class="navbar-brand" href="{{ route('events.index') }}">Home</a>
        <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent"
            aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
            <span class="navbar-toggler-icon"></span>
        </button>

        <div class="collapse navbar-collapse" id="navbarSupportedContent">
            <ul class="navbar-nav mr-auto">
                <li class="nav-item active">
                    <a class="nav-link" href="{{url('events/invitation')}}">Invitations<span class="sr-only">(current)</span>
                        @php
                            $invt = App\Models\EventUser::where('user_id', auth()->user()->id)
                                         ->get();
                        @endphp
                        <span class="badge badge-pill badge-info">{{count($invt)}}</span>
                    </a>
                </li>
                <li class="nav-item active">
                    <a class="nav-link" href="{{url('dashboard')}}">Dashboard</a>
                </li>
            </ul>
            <form class="form-inline my-2 my-lg-0" action="{{url('/events/search')}}" method="POST">
                @csrf
                <input class="form-control mr-sm-2" type="text" placeholder="Search" name="search" aria-label="Search">
                <button class="btn btn-outline-success my-2 my-sm-0" type="submit">Search</button>
            </form>
            <form method="POST" action="{{ route('logout') }}">
                @csrf

                <a class="btn btn-sm btn-danger ml-2" href="{{ route('logout') }}"
                         onclick="event.preventDefault();
                                this.closest('form').submit();">
                    {{ __('Log Out') }}
                </a>
            </form>
        </div>
    </nav>
    <div class="container">
        <div class="row">
            <div class="col-md-12">
                <h1>Event Management System</h1>
            </div>
        </div>
        <div class="row">
            <div class="col-md-12">
                <button data-toggle="modal" data-target="#addEvent" class="btn btn-primary m-3 btn-block">Create
                    Event</button>
                @if ($errors->any())
                    @foreach ($errors->all() as $err)
                        <div class="alert alert-primary alert-dismissible fade show" role="alert">{{ $err }}
                            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                                <span aria-hidden="true">&times;</span>
                            </button>
                        </div>
                    @endforeach
                @endif
                @if (session('msg'))
                    <div class="alert alert-primary alert-dismissible fade show" role="alert">
                        {{ session('msg') }}
                        <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                @endif
            </div>
        </div>
        @yield('content')
    </div>
    <script src="https://code.jquery.com/jquery-3.3.1.slim.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.3/umd/popper.min.js"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.1.3/js/bootstrap.min.js"></script>
</body>

</html>

resources/views/events/index.blade.php
@extends('events.app')
@section('content')
    <div class="row">
        <div class="col-md-12">
            <table class="table table-bordered">
                <thead>
                    <tr>
                        <th>@sortablelink('id')</th>
                        <th>@sortablelink('name')</th>
                        <th>Description</th>
                        <th>Members</th>
                        <th>@sortablelink('event_date', 'Event Date')</th>
                        <th>@sortablelink('event_time', 'Event Time')</th>
                        <th>Action</th>
                    </tr>
                </thead>
                <tbody>
                    @foreach ($events as $event)
                        <tr>
                            @php
                                $user = App\Models\EventUser::where('event_id', $event->id)
                                    ->with('user')
                                    ->get();
                            @endphp
                            <td>{{ $loop->iteration }}</td>
                            <td>{{ $event->name }} <span class="badge badge-info">{{ count($user) }}</span> </td>
                            <td>{{ $event->description }}</td>
                            <td>
                                <ul>
                                    @foreach ($user as $item)
                                        <li>{{ $item->user->name }}
                                            @if ($item->is_accept)
                                                <span class="badge badge-pill badge-success">Accepted</span>
                                            @else
                                                <span class="badge badge-pill badge-warning">Pending</span>
                                            @endif
                                            <form action="{{ url('remove-member/' . $item->id) }}" method="POST">
                                                @csrf
                                                @method('DELETE')
                                                <button type="submit" class="badge badge-danger">Remove</button>
                                            </form>
                                        </li>
                                    @endforeach
                                </ul>
                            </td>
                            <td>{{ $event->event_date }}</td>
                            <td>{{ $event->event_time }}</td>
                            <td>
                                @if ($event->user_id == Auth::user()->id)
                                    <a class="btn btn-primary btn-sm m-1"
                                        href="{{ url('invite-members/' . $event->id) }}">Invite</a>
                                    <form action="{{ route('events.destroy', $event->id) }}" method="POST">
                                        @csrf
                                        @method('DELETE')
                                        <a class="btn btn-warning btn-sm"
                                            href="{{ url('events/' . $event->id . '/edit') }}">Update</a>
                                        <button type="submit" class="btn btn-danger btn-sm m-1">Delete</button>
                                    </form>
                                @endif
                            </td>
                        </tr>
                    @endforeach
                </tbody>
            </table>
            {{ $events->links() }}
        </div>
    </div>
    @include('events.addevent-modal')
@endsection

resources/views/events/invitation.blade.php
@extends('events.app')
@section('content')
    <div class="row">
        <div class="col-md-12">
            <table class="table table-bordered">
                <thead>
                    <tr>
                        <th>ID</th>
                        <th>Name</th>
                        <th>Description</th>
                        <th>Event Date</th>
                        <th>Event Time</th>
                        <th>@sortablelink('is_accept', 'Action')</th>
                    </tr>
                </thead>
                <tbody>
                    @if (count($invitation) > 0)
                        @foreach ($invitation as $item)
                            <tr>
                                <td>{{ $loop->iteration }}</td>
                                <td>{{ $item->event->name }}</td>
                                <td>{{ $item->event->description }}</td>
                                <td>{{ $item->event->event_date }}</td>
                                <td>{{ $item->event->event_time }}</td>
                                <td>
                                    @if ($item->is_accept)
                                        <span class="badge badge-pill badge-success p-2">Accepted</span>
                                    @else
                                        <a class="btn btn-primary btn-sm m-1"
                                            href="{{ url('accept-invitation/' . $item->id) }}">Accept</a>
                                    @endif
                                </td>
                            </tr>
                        @endforeach
                    @else
                        <span class="badge badge-pill badge-danger m-2">Oops! No invitaation</span>
                    @endif
                </tbody>
            </table>
            {{ $invitation->links() }}
        </div>
    </div>
    @include('events.addevent-modal')
@endsection

resources/views/events/inviteMember.blade.php
@extends('events.app')
@section('content')
    <div class="row">
        <div class="col-md-12">
            <form action="{{ url('sent-invititation') }}" method="post">
                @csrf
                <div class="input-group mb-3">
                    <div class="input-group-prepend">
                        <label class="input-group-text" for="inputGroupSelect01">Select members</label>
                    </div>
                    <input type="hidden" name="event_id" value="{{$event->id}}">
                    <select name="user_id[]" class="custom-select" id="inputGroupSelect01" multiple>
                        @foreach ($users as $item)
                            <option value="{{ $item->id }}">{{ $item->name }}</option>
                        @endforeach
                    </select>
                </div>

        </div>
        <button type="submit" class="btn btn-primary btn-block">Sent Invitation</button>
        </form>
    </div>
    </div>
    @include('events.addevent-modal')
@endsection

resources/views/events/search.blade.php
@extends('events.app')
@section('content')
    <div class="row">
        <div class="col-md-12">
            <table class="table table-bordered">
                <thead>
                    <tr>
                        <th>@sortablelink('id')</th>
                        <th>@sortablelink('name')</th>
                        <th>Description</th>
                        <th>Members</th>
                        <th>@sortablelink('event_date', 'Event Date')</th>
                        <th>@sortablelink('event_time', 'Event Time')</th>
                        <th>Action</th>
                    </tr>
                </thead>
                <tbody>
                    @if (count($events) > 0)
                        @foreach ($events as $event)
                            <tr>
                                @php
                                    $user = App\Models\EventUser::where('event_id', $event->id)
                                        ->with('user')
                                        ->get();
                                @endphp
                                <td>{{ $loop->iteration }}</td>
                                <td>{{ $event->name }} <span class="badge badge-info">{{ count($user) }}</span> </td>
                                <td>{{ $event->description }}</td>
                                <td>
                                    <ul>
                                        @foreach ($user as $item)
                                            <li>{{ $item->user->name }}
                                                @if ($item->is_accept)
                                                    <span class="badge badge-pill badge-success">Accepted</span>
                                                @else
                                                    <span class="badge badge-pill badge-warning">Pending</span>
                                                @endif
                                                <form action="{{ url('remove-member/' . $item->id) }}" method="POST">
                                                    @csrf
                                                    @method('DELETE')
                                                    <button type="submit" class="badge badge-danger">Remove</button>
                                                </form>
                                            </li>
                                        @endforeach
                                    </ul>
                                </td>
                                <td>{{ $event->event_date }}</td>
                                <td>{{ $event->event_time }}</td>
                                <td>
                                    @if ($event->user_id == Auth::user()->id)
                                        <a class="btn btn-primary btn-sm m-1"
                                            href="{{ url('invite-members/' . $event->id) }}">Invite</a>
                                        <form action="{{ route('events.destroy', $event->id) }}" method="POST">
                                            @csrf
                                            @method('DELETE')
                                            <a class="btn btn-warning btn-sm" href="{{url('events/'.$event->id.'/edit')}}">Update</a>
                                            <button type="submit" class="btn btn-danger btn-sm m-1">Delete</button>
                                        </form>
                                    @else
                                        {{-- <a href="{{ route('events.show', $event->id) }}"
                                            class="btn btn-primary btn-sm">Join</a> --}}
                                    @endif
                                </td>
                            </tr>
                        @endforeach
                        @else
                        <span class="badge badge-pill badge-danger m-2">Oops! No Event found</span>
                    @endif
                </tbody>
            </table>
        </div>
    </div>
    @include('events.addevent-modal')
@endsection